import { Component, EventEmitter, Input, Output } from '@angular/core';
import { Category } from '../../../structure-list/models/category.model';
import { Module } from '../../../structure-list/models/module.model';

@Component({
  selector: 'app-collapsable-filter',
  templateUrl: './collapsable-filter.component.html',
  styleUrls: ['./collapsable-filter.component.scss'],
})
export class CollapsableFilterComponent {
  /** Label */
  @Input({ required: true }) label: string;

  /** Categories for checkboxes */
  @Input({ required: true }) categories: Category[];

  /** Checked modules */
  @Input() checkedModules: Module[] = [];

  /** Display Radio buttons instead of checkboxes */
  @Input() isRadio = false;

  /** Selected modules event */
  @Output() selectEvent = new EventEmitter();

  /** Is showing the options ? */
  public expanded = false;

  // Sends an array containing all modules
  public emitModules(m: Module[]): void {
    this.selectEvent.emit(m);
    this.closeModal();
  }

  public toggleExpanded(): void {
    this.expanded = !this.expanded;
  }

  public closeModal(): void {
    this.expanded = false;
  }
}
